#include<stdio.h>
#include<limits.h>

struct node{
	int val;
	int listNo;
} heap[1000];

int heapSize;

void Init()
{
	heapSize = 0;
 	heap[0].val = -INT_MAX;
 	heap[0].listNo = -1;
}

void Insert(int element, int no)
{
	int now;
	
	heapSize++;
	heap[heapSize].val = element;
	heap[heapSize].listNo = no;
	
	now = heapSize;
	while(heap[now/2].val > element) 
	{
		heap[now].val = heap[now/2].val;
		heap[now].listNo = heap[now/2].listNo;
		now /= 2;
	}
	heap[now].val = element;
	heap[now].listNo = no;
}

struct node DeleteMin()
{
	struct node minElement,lastElement;
	int child,now;
	minElement = heap[1];
	lastElement = heap[heapSize--];
	/* now refers to the index at which we are now */
	for(now = 1; now*2 <= heapSize ;now = child)
	{
		child = now*2;
		if(child != heapSize && heap[child+1].val < heap[child].val ) 
		{
			child++;
		}
		if(lastElement.val > heap[child].val)
		{
			heap[now].val = heap[child].val;
			heap[now].listNo = heap[child].listNo;
		}
		else break;
	}
	heap[now] = lastElement;
	return minElement;
}
int main()
{
	int number_of_lists, number_of_elements[1000];
	int i, j, total, element[1000][1000], pointer[1000];
	struct node temp;
	
	freopen("./in3", "r", stdin);
	freopen("./out3", "w", stdout);
	
	scanf("%d",&number_of_lists);
	total = 0;
	for (i = 0; i<number_of_lists; i++)
	{
		pointer[i] = 0;
		scanf("%d",&number_of_elements[i]);
		total += number_of_elements[i];
		for (j = 0; j<number_of_elements[i]; j++)
		{
			scanf("%d",&element[i][j]);
		}
	}
	
	Init();
	for(i = 0; i<number_of_lists; i++)
	{
		Insert(element[i][pointer[i]], i);
		pointer[i] += 1;
	}
	//printf("%d\n", heapSize);
	//for (i = 0; i<number_of_lists; i++) printf("%d ", heap[i+1].val);

	while (total)
	{
		temp = DeleteMin();
		printf("%d\n", temp.val);
		total -= 1;
		if (pointer[temp.listNo]<number_of_elements[temp.listNo])
		{
			Insert(element[temp.listNo][pointer[temp.listNo]], temp.listNo);
			pointer[temp.listNo] += 1;
		}
	}
	return 0;
}
